



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[ES6] Function Params</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[ES6] Function Params</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 00:24:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1. Default Value of function param:</p>
<p>The function&nbsp;<code>displayTopicsPreview()</code>&nbsp;raises an error on the very first line when called with no arguments. Let's fix that!</p>
<div>
<pre class="prettyprint linenums">function displayTopicsPreview( topics ){<br />
  var message = "There are currently " + topics.length;<br />
  _displayPreviewMessage(topics, message);<br />
}

-----------------

function displayTopicsPreview( topics = [] ){<br />
  let message = "There are currently " + topics.length;<br />
  _displayPreviewMessage(topics, message);<br />
}</pre>
</div>
<p>2.&nbsp;Complete the&nbsp;<code>setPageThread()</code>&nbsp;function signature with the missing named parameters. You can check out the body of the function to help discover what options are expected.</p>
<div>
<pre class="prettyprint linenums">function setPageThread(name,  ){<br />
  let nameElement = _buildNameElement(name);<br />
  let settings = _parseSettings(popular, expires, activeClass);

  _updateThreadElement(nameElement, settings);<br />
}

-------------------

function setPageThread(name,  {popular, expires, activeClass}){<br />
  let nameElement = _buildNameElement(name);<br />
  let settings = _parseSettings(popular, expires, activeClass);

  _updateThreadElement(nameElement, settings);<br />
}</pre>
</div>
<p>3.&nbsp;Let's refactor the&nbsp;<code>loadProfiles()</code>&nbsp;function to use named parameters with default values.</p>
<div>
<div>
<pre class="prettyprint linenums">function loadProfiles(userNames = [], options = {}) {<br />
  let profilesClass = options.profilesClass || ".user-profile";<br />
  let reverseSort   = options.reverseSort   || false;

  if (reverseSort) {<br />
    userNames = _reverse(userNames);<br />
  }

  _loadProfilesToSideBar(userNames, profilesClass);<br />
}

------------------------------

function loadProfiles(userNames = [], {profilesClass, reverseSort} = {}) {<br />
  profilesClass = profilesClass || ".user-profile";<br />
  reverseSort   = reverseSort   || false;

  if (reverseSort) {<br />
    userNames = _reverse(userNames);<br />
  }

  _loadProfilesToSideBar(userNames, profilesClass);<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">function setPageThread(name, {popular, expires, activeClass} = {}){<br />
  // ...<br />
}

setPageThread("ES2015", {<br />
    popular: true<br />
}); 

//won't cause error</pre>
</div>
<p>Important to take away from here is</p>
<ul><li>Instead of giving options = {} in the function param, we give {profileClass, reserseSort} = {}</li>
<li>First it is more clear to see what "options" it is</li>
<li>Second we assign default param here.</li></ul>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mvv08k.html">JavaScript高级编程 &lpar;2&rpar; - HTML 与 JavaScript</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gmmle9.html">Google C&plus;&plus;单元测试框架GoogleTest---GMock的CheatSheet文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rywwr8.html">centos查看实时网络带宽占用情况方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oggjlq.html">CLR via C&num; 3rd - 07 - Constants and Fields</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evmzz9.html">JDK版本不兼容问题之：一台机器安装多个版本的JDK</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxv0yv9.html">使用Html5&plus;C&num;&plus;微信 开发移动端游戏详细教程  &colon;（一）序（关于作者创业失败的感想）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4955zr09.html">ROSE User Case View</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k112kj9.html">EMV技术学习和研究&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlml5ke9.html">centos 连不上网</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mnxm9.html">VBS基础篇 - 内置函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xd31r9.html">【Siverlight - 扩展篇】Silverlight在OOB模式下实现默认打开最大化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06nzeq.html">&lbrack;Node&period;js&rsqb; Web Scraping with Pagination and Advanced Selectors</a>
		</li>
						<li><a href="https://www.batexi.com/a/96on3wn9.html">【转】 U3D DrawCall优化手记 - 夜阑卧听风吹雨</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojnrmlq.html">怎样删除在Github中创建的项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mm6o48.html">AsyncTask来源分析&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpj4zxq.html">hbase checkandput</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk23ye8.html">Java web项目综合练习（Estore）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kply179.html">基于fitnesse浅析waferslim引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rrdxo9.html">DataOutputStream and DataInputStream</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ryy568.html">the principle of redbalck tree</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1ezx39.html">rmi rpc restful soa 区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z77659.html">Windows Server 2003 SP2 R2 企业版&sol;标准版&sol;32与64位 CD-KEY</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok6en59.html">Linux下安装Oracle 10g&lpar;redhat 4&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok6e5p9.html">用CAGradientLayer实现渐变色动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj4r5k9.html">PHP中的定界符格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z7g209.html">机器学习之python： kNN</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xorxm8.html">d023&colon; 各位数字之和</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2klk8.html">Autofact 的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k170379.html">Linux下使用QQ的几种方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1wopx9.html">SQLiteDatabase中的事务</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
